#include "ti83plus.inc"
#include "mirage.inc"
	.org	$9d93				;Origin (set back two to account for AsmPrgm)
	.db	$BB,$6D				;Compiled AsmPrgm token
	ret					;So TIOS wont run the program
	.db	1				;Identifier as MirageOS program
	.db	%00000000,%00000000
	.db	%01000010,%01111100		;15x15 button
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01111110,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%00010000
	.db	%01000010,%01111100
	.db	%00000000,%00000000
	.db	"Sprite routine",0			;Zero terminated description
						;Program code starts here
	
#define _misn_xor
	di
	ld ix,vars
redraw:
	call sprite_misn
	call iFastCopy
	call sprite_misn
badkey:
	bcall(_getcsc)
	cp skUp
	jr z,moveup
	cp skDown
	jr z,movedown
	cp skRight
	jr z,moveright
	cp skLeft
	jr z,moveleft
	cp sk2nd
	jr z,enlarge
	cp skAlpha
	jr z,reduce
	cp skClear
	ret z
	jr badkey
moveup:
	xor a
	or (ix+1)
	jr z,badkey
	dec (ix+1)
	jr redraw
moveleft:
	xor a
	or (ix)
	jr z,badkey
	dec (ix)
	jr redraw
movedown:
	ld e,(ix+2)
	ld h,(ix+3)
	call multhe
	ld a,(ix+1)
	add a,l
	cp 64
	jr z,badkey
	inc (ix+1)
	jr redraw
moveright:
	ld e,(ix+2)
	ld h,(ix+4)
	sla h
	sla h
	sla h
	call multhe
	ld a,(ix)
	add a,l
	cp 96
	jr z,badkey
	inc (ix)
	jr redraw
reduce:
	dec (ix+2)
	jr nz,redraw
	inc (ix+2)
	jr badkey
enlarge:
	ld e,(ix+2)
	ld h,(ix+4)
	sla h
	sla h
	sla h
	call multhe
	ld a,(ix)
	add a,l
	cp 96-7
	jp nc,badkey
	ld e,(ix+2)
	ld h,(ix+3)
	call multhe
	ld a,(ix+1)
	add a,l
	cp 64-7
	jp nc,badkey
	inc (ix+2)
	jp redraw
vars:
	.db 20		;0 x/col
	.db 4		;1 y/row
	.db 7		;2 scale factor
	.db 8		;3 height
	.db 1		;4 byte width
	.dw sprite	;pointer
	.db 0,0		;used by routine
sprite:
	.db %00111100
	.db %01000010
	.db %10101001
	.db %10101001
	.db %11000101
	.db %10111001
	.db %01000010
	.db %00111100
#include "misn.asm"

.end