x_coord =0		; column, leftmost is 0
y_coord =1		; row, topmost is 0
scale_factorm =2	; multiple of original size to display at (never use $FF as a multiple!!!)
scale_factorf =3	; fraction added to multiple ($00 - $FF <-> 0/256 - 255/256)
sprite_height =4	; pixel height
byte_width =5		; number of bytes wide, not pixels
sprite_loc_lsb =6	; Pointer to actual sprite
sprite_loc_msb =7	; second byte of pointer
bit_counter =8		; I ran out of registers so i used these instead.
bit_counter2 =9		; (go ahead and moify them, but they will be reset by the routine)

sprite_fisn:
	ld a,(ix+byte_width)
	add a,a
	add a,a
	add a,a
	ld (sprite_width),a
	ld e,(ix+y_coord)
	ld h,0
	ld d,h
	ld l,e
	add hl,de
	add hl,de
	add hl,hl
	add hl,hl
	ld a,(ix+x_coord)
	ld e,a
	and 7
	ld (offset_in_byte),a
	neg
	add a,8
	ld (start_do),a
	srl e
	srl e
	srl e
	add hl,de
	ld de,plotsscreen
	add hl,de	;hl->spot on gbuf
	ld d,(ix+sprite_loc_msb)
	ld e,(ix+sprite_loc_lsb) ;de->sprite
	ex de,hl
	ld c,(ix+sprite_height)
	ld a,-1
next_sprite_row:
	ld b,(ix+scale_factorm)
	add a,(ix+scale_factorf)
	push af
	jr c,do_inc
	dec b
do_inc:
	inc b
	jr z,skip_sprite_row
next_gbuf_row:
	push bc
	push hl
	push de
offset_in_byte =$+1
	ld b,0
	ld a,(de)
pre_shift_loop:
	rlca
	djnz pre_shift_loop
	ld (de),a
start_do =$+1
	ld a,0
	ld (ix+bit_counter2),a
	ld (ix+bit_counter),8
sprite_width =$+1
	ld c,0
	ld a,-1
next_sprite_pixel:
	ld b,(ix+scale_factorm)
	add a,(ix+scale_factorf)
	push af
	jr c,do_inc2
	dec b
do_inc2:
	inc b
	jr z,skip_sprite_pixel
next_gbuf_pixel:
#ifdef _fisn_ld
	rlc (hl)
	ld a,(de)
	rla
	ld (de),a
	rrc (hl)
#endif
#ifdef _fisn_or
	rlc (hl)
	ld a,(de)
	jr c,bitisone
	rlca
	jr donebitor
bitisone:
	rla
donebitor:
	ld (de),a
	rrc (hl)
#endif
#ifdef _fisn_xor
	rlc (hl)
	ld a,(de)
	jr c,switchbit
	rlca
	jr donebitxor
switchbit:
	rlca
	xor 1
donebitxor:
	ld (de),a
	rrc (hl)
#endif
	dec (ix+bit_counter2)
	jr nz,no_inc
	inc de
	ld (ix+bit_counter2),8
no_inc:
	djnz next_gbuf_pixel
skip_sprite_pixel:
	pop af
	rlc (hl)
	dec (ix+bit_counter)
	jr nz,no_inc2
	inc hl
	ld (ix+bit_counter),8
no_inc2:
	dec c
	jr nz,next_sprite_pixel
	ld b,(ix+bit_counter2)
	ld a,(de)
post_shift_loop:
	rlca
	djnz post_shift_loop
	ld (de),a
	ld bc,12
	pop hl		;pop de
	add hl,bc	;add de,12
	ex de,hl
	pop hl
	pop bc
	djnz next_gbuf_row
skip_sprite_row:
	push de
	ld d,0
	ld e,(ix+byte_width)
	add hl,de
	pop de
	pop af
	dec c
	jr nz,next_sprite_row
	ret